---
layout: lesson
---
This lesson shows how to use the
[Software Carpentry]({{ site.swc_site }}) and
[Data Carpentry]({{ site.dc_site }}) lesson template.
For guidelines on how to help improve our lessons and this template,
please see [the contribution guidelines][contributing];
for guidelines on how to set up your machine to preview changes locally,
please see [the setup instructions]({{ site.github.url }}/setup/).

> ## Prerequisites
>
> Use the `.prereq` style to specify prerequisites.
{: .prereq}

> ## Ten Things You Need To Know
>
> 0.  Don't panic.
> 1.  Create a new lesson by using GitHub Import, *not* by forking.
> 2.  Run `bin/lesson_inititialize.py` *once* in a new lesson repository to set up standard files.
> 3.  Run `make lesson-check` to check that the lesson is formatted correctly.
> 4.  Put lesson episodes in `_episodes` (or `_episodes_rmd` if you are writing in RMarkdown).
> 5.  Run `make serve` to preview the lesson website locally.
> 6.  Do *not* commit the generated HTML files in the `_site` directory.
> 7.  Style blocks and code samples by putting `{: .stylename}` *after* the block or code.
> 8.  Put solutions inside challenges using nested blockquotes.
> 9.  File issues and template fixes in the [styles repository][styles],
>     and enhancements to this documentation in this one.
{: .checklist}

[contributing]: {{ site.github.repository_url }}/blob/gh-pages/CONTRIBUTING.md
[styles]: https://github.com/swcarpentry/styles/
